<?php
if(is_admin())
{
    $learnomatic_Main_Settings = get_option('learnomatic_Main_Settings', false);
    $redirect = admin_url('admin.php?page=learnomatic_rakuten_panel&yt_auth_done=true');
    $redirect2 = admin_url('admin.php?page=learnomatic_rakuten_panel&yt_auth_done=false');
    $rakufailed = false;
    if(isset($_POST['learnomatic_auth']) && isset($_REQUEST['page']) && $_REQUEST['page'] == 'learnomatic_rakuten_panel')
    {
       try
       {
            $url              = 'https://api.linksynergy.com/token';
            $ch               = curl_init();
            if ($ch === FALSE) {
                $rakufailed = true;
                learnomatic_log_to_file('Failed to init curl!');
            }
            $authoriz = base64_encode(trim($learnomatic_Main_Settings['rakuten_key']) . ':' . trim($learnomatic_Main_Settings['rakuten_secret']));
            $authoriz = 'Bearer ' . $authoriz;
            $headers = [
                'Authorization: ' . $authoriz,
                'Content-Type: application/x-www-form-urlencoded'
            ];
            $data = array();
            $data['scope'] = trim($learnomatic_Main_Settings['rakuten_id']);
            $fdata = "";
            foreach ($data as $key => $val) {
                $fdata .= "$key=" . urlencode($val) . "&";
            }
            $fdata = trim($fdata, '&');
            curl_setopt($ch, CURLOPT_POSTFIELDS, $fdata);
            curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
            curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 10);
            curl_setopt($ch, CURLOPT_TIMEOUT, 60);
            curl_setopt($ch, CURLOPT_URL, $url);
            curl_setopt($ch, CURLOPT_POST, true);
            curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
            curl_setopt($ch, CURLOPT_REFERER, $url);
            $html = curl_exec($ch);
            curl_close($ch);
            if ($html === FALSE || stristr($html, 'error_description') !== false) {
                $rakufailed = true;
                learnomatic_log_to_file('"Rakuten API Credentials" failed to exec curl: ' . $html);
            }
            else
            {
                $at = json_decode($html, true);
                if(isset($at['access_token']))
                {
                    update_option('learnomatic_access_token_auth_id', $learnomatic_Main_Settings['rakuten_key']);
                    update_option('learnomatic_access_token_auth_secret', $learnomatic_Main_Settings['rakuten_secret']);
                    $at['expires_in'] = intval($at['expires_in']) + time();
                    $at = json_encode($at);
                    update_option('learnomatic_access_token_str', $at);
                }
                else
                {
                    $rakufailed = true;
                    learnomatic_log_to_file('No valid access token found: ' . print_r($html, true));
                }
            }  
        }
        catch(Exception $e)
        {
            $rakufailed = true;
            learnomatic_log_to_file('Exception thrown in Rakuten Auth auth: ' . $e->getMessage());
        }
        if($rakufailed == true)
        {
            header('Location: ' . $redirect2);
        }
        else
        {
            header('Location: ' . $redirect);
        }
        die();
    }
}
function learnomatic_rakuten_panel()
{
    $learn_languages = array(
		'en_US' => 'English' , 
		'fr_FR' => 'French' , 
		'de_DE' => 'German' , 
		'pt_BR' => 'Brazilian Portuguese'
		);
   $learnomatic_Main_Settings = get_option('learnomatic_Main_Settings', false);
   $authorized = false;
   if(!isset($learnomatic_Main_Settings['rakuten_id']) || $learnomatic_Main_Settings['rakuten_id'] == '')
   {
   ?>
<h1><?php echo esc_html__("You must add an Rakuten Advertising Site ID in the plugin settings, before you can use this feature!", 'learnomatic-udemy-affiliate-post-generator');?></h1>
<?php
   return;
   }
   if(!isset($learnomatic_Main_Settings['rakuten_secret']) || $learnomatic_Main_Settings['rakuten_secret'] == '')
   {
   ?>
<h1><?php echo esc_html__("You must add an Rakuten User Password in the plugin settings, before you can use this feature!", 'learnomatic-udemy-affiliate-post-generator');?></h1>
<?php
   return;
   }
   if(!isset($learnomatic_Main_Settings['rakuten_key']) || $learnomatic_Main_Settings['rakuten_key'] == '')
   {
   ?>
<h1><?php echo esc_html__("You must add an Rakuten User Name in the plugin settings, before you can use this feature!", 'learnomatic-udemy-affiliate-post-generator');?></h1>
<?php
   return;
   }
   if(get_option('learnomatic_access_token_auth_id', false) !== FALSE)
   {
       if(get_option('learnomatic_access_token_auth_secret', false) !== FALSE)
       {
           if($learnomatic_Main_Settings['rakuten_key'] == get_option('learnomatic_access_token_auth_id', false) && $learnomatic_Main_Settings['rakuten_secret'] == get_option('learnomatic_access_token_auth_secret', false) && get_option('learnomatic_access_token_str', false) !== FALSE)
           {
               $authorized = true;
           }
       }
   }
   ?>
<div class="wp-header-end"></div>
<div class="wrap gs_popuptype_holder seo_pops">
   <div>
      <?php
         if($authorized === FALSE)
         {
         ?>
      <div class="hideThis">
         <h1><?php echo esc_html__("Click the button below to authorize connection to the Rakuten Consumer API:", 'learnomatic-udemy-affiliate-post-generator');?></h1>
      </div>
      <br/>
      <form id="myAuthForm" method="post" action=""><input type="submit" name="learnomatic_auth" id="btnSubmit" class="button button-primary" onclick="unsaved = false;" value="<?php if($authorized === TRUE){echo esc_html__('Reauthorize the App', 'learnomatic-udemy-affiliate-post-generator');}else{echo esc_html__('Authorize the App', 'learnomatic-udemy-affiliate-post-generator');}?>"/></form>
      <?php
         update_option('learnomatic_access_token_auth_id', 'null');
         update_option('learnomatic_access_token_auth_secret', 'null');
         ?>
      <h1><?php echo esc_html__("You must authorize your App before using this plugin feature!", 'learnomatic-udemy-affiliate-post-generator');?></h1>
      <?php
         }
         else
         {
             if(isset($_REQUEST['yt_auth_done']))
             {
                 if($_REQUEST['yt_auth_done'] == 'true')
                 {
         ?>
      <div id="message" class="updated">
         <p class="cr_saved_notif"><strong>&nbsp;<?php echo esc_html__("Rakuten authorization successful!", 'learnomatic-udemy-affiliate-post-generator');?></strong></p>
      </div>
      <?php
                 }
                 else
                 {
                     ?>
      <div id="message" class="updated">
         <p class="cr_saved_notif"><strong>&nbsp;<?php echo esc_html__("Rakuten authorization FAILED!", 'learnomatic-udemy-affiliate-post-generator');?></strong></p>
      </div>
      <?php
                 }
                     
            }
         ?>
      <br/>
      <form id="myAuthForm" method="post" action=""><input type="submit" name="learnomatic_auth" id="btnSubmit" class="button button-primary" onclick="unsaved = false;" value="<?php if($authorized === TRUE){echo esc_html__('Reauthorize the App', 'learnomatic-udemy-affiliate-post-generator');}else{echo esc_html__('Authorize the App', 'learnomatic-udemy-affiliate-post-generator');}?>"/></form>
      <form id="myForm" method="post" action="admin.php?page=learnomatic_rakuten_panel">
         <?php
            wp_nonce_field('learnomatic_save_rules', '_learnomaticr_nonce');
            
            if (isset($_GET['settings-updated'])) {
            ?>
         <div>
            <p class="cr_saved_notif"><strong><?php echo esc_html__("Settings saved.", 'learnomatic-udemy-affiliate-post-generator');?></strong></p>
         </div>
         <?php
            }
            ?>
         <div>
            <div class="hideMain">
               <hr/>
               <div class="table-responsive">
                  <table id="mainRules" class="responsive table cr_main_table">
                     <thead>
                        <tr>
                           <th>
                              <?php echo esc_html__("ID", 'learnomatic-udemy-affiliate-post-generator');?>
                              <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                 <div class="bws_hidden_help_text cr_min_260px">
                                    <?php
                                       echo esc_html__("This is the ID of the rule.", 'learnomatic-udemy-affiliate-post-generator');
                                       ?>
                                 </div>
                              </div>
                           </th>
                           <th>
                              <?php echo esc_html__("Keyword Search", 'learnomatic-udemy-affiliate-post-generator');?>
                              <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                 <div class="bws_hidden_help_text cr_min_260px">
                                    <?php
                                       echo sprintf( wp_kses( __( "Input your queried keyword. Posts will be generated based on these keywords. To get all products that match your criteria, input '*' (without commas). Space between words = AND. Comma (,) between words = requires an exact sequence of words. Minus (\"-\") sign before a word = Exclude results that match that word. Comma between words in parentheses with no spaces (baseball,card) = OR between words. Minus (\"-\") sign before a group of words in parentheses baseball -(autograph,card,star)	= remove all results that match any of these words. Asterisk (\"*\") = Substitutes for one or more characters. Read more about this, <a href='%s' target='_blank'>here</a> - Update: nested shortcodes also supported (shortcodes generated by rules from other plugins).", 'learnomatic-udemy-affiliate-post-generator'), array(  'a' => array( 'href' => array(), 'target' => array() ) ) ), esc_url( 'https://developer.udemy.com/Devzone/finding/Concepts/FindingAPIGuide.html' ) );
                                       ?>
                                 </div>
                              </div>
                           </th>
                           <th>
                              <?php echo esc_html__("Schedule", 'learnomatic-udemy-affiliate-post-generator');?>
                              <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                 <div class="bws_hidden_help_text cr_min_260px">
                                    <?php
                                       echo esc_html__("Select the interval in hours after which you want this rule to run. Defined in hours.", 'learnomatic-udemy-affiliate-post-generator');
                                       ?>
                                 </div>
                              </div>
                           </th>
                           <th>
                              <?php echo esc_html__("Max # Posts", 'learnomatic-udemy-affiliate-post-generator');?>
                              <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                 <div class="bws_hidden_help_text cr_min_260px">
                                    <?php
                                       echo esc_html__("Select the maximum number of posts that this rule can create at once. 0-100 interval allowed.", 'learnomatic-udemy-affiliate-post-generator');
                                       ?>
                                 </div>
                              </div>
                           </th>
                           <th>
                              <?php echo esc_html__("Post Status", 'learnomatic-udemy-affiliate-post-generator');?>
                              <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                 <div class="bws_hidden_help_text cr_min_260px">
                                    <?php
                                       echo esc_html__("Select the status that you want for the automatically generated posts to have.", 'learnomatic-udemy-affiliate-post-generator');
                                       ?>
                                 </div>
                              </div>
                           </th>
                           <th>
                              <?php echo esc_html__("Item Type", 'learnomatic-udemy-affiliate-post-generator');?>
                              <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                 <div class="bws_hidden_help_text cr_min_260px">
                                    <?php
                                       echo esc_html__("Select the type (post/page) for your automatically generated item.", 'learnomatic-udemy-affiliate-post-generator');
                                       ?>
                                 </div>
                              </div>
                           </th>
                           <th>
                              <?php echo esc_html__("Post Author", 'learnomatic-udemy-affiliate-post-generator');?>
                              <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                 <div class="bws_hidden_help_text cr_min_260px">
                                    <?php
                                       echo esc_html__("Select the author that you want to assign for the automatically generated posts.", 'learnomatic-udemy-affiliate-post-generator');
                                       ?>
                                 </div>
                              </div>
                           </th>
                           <th>
                              <?php echo esc_html__("More Options", 'learnomatic-udemy-affiliate-post-generator');?>
                              <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                 <div class="bws_hidden_help_text cr_min_260px">
                                    <?php
                                       echo esc_html__("Shows advanced settings for this rule.", 'learnomatic-udemy-affiliate-post-generator');
                                       ?>
                                 </div>
                              </div>
                           </th>
                           <th class="cr_max_width_40">
                              <?php echo esc_html__("Del", 'learnomatic-udemy-affiliate-post-generator');?>
                              <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                 <div class="bws_hidden_help_text cr_min_260px">
                                    <?php
                                       echo esc_html__("Do you want to delete this rule?", 'learnomatic-udemy-affiliate-post-generator');
                                       ?>
                                 </div>
                              </div>
                           </th>
                           <th class="cr_max_55">
                              <?php echo esc_html__("Active", 'learnomatic-udemy-affiliate-post-generator');?>
                              <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                 <div class="bws_hidden_help_text cr_min_260px">
                                    <?php
                                       echo esc_html__("Do you want to enable this rule? You can deactivate any rule (you don't have to delete them to deactivate them).", 'learnomatic-udemy-affiliate-post-generator');
                                       ?>
                                 </div>
                              </div>
                              <br/>
                              <input type="checkbox" onchange="thisonChangeHandler(this)" id="exclusion">
                           </th>
                           <th class="cr_max_42">
                              <?php echo esc_html__("Info", 'learnomatic-udemy-affiliate-post-generator');?>
                              <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                 <div class="bws_hidden_help_text cr_min_260px">
                                    <?php
                                       echo esc_html__("The number of items (posts, pages) this rule has generated so far.", 'learnomatic-udemy-affiliate-post-generator');
                                       ?>
                                 </div>
                              </div>
                           </th>
                           <th class="cr_actions">
                              <?php echo esc_html__("Actions", 'learnomatic-udemy-affiliate-post-generator');?>
                              <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                 <div class="bws_hidden_help_text cr_min_260px">
                                    <?php
                                       echo esc_html__("Do you want to run this rule now? Note that only one instance of a rule is allowed at once.", 'learnomatic-udemy-affiliate-post-generator');
                                       ?>
                                 </div>
                              </div>
                           </th>
                        </tr>
                        
                     </thead>
                     <tbody>
                        <?php
                           echo learnomatic_expand_rules_rakuten($learn_languages);
                           ?>
                        
                        <tr>
                           <td class="cr_short_td">-</td>
                           <td class="cr_select_option"><input type="text" name="learnomatic_rakuten_list[rule_keywords][]" placeholder="Please input your search keywords" value="" class="cr_width_full"/></td>
                           <td class="cr_comm_td"><input type="number" step="1" min="1" name="learnomatic_rakuten_list[schedule][]" max="8765812" class="cr_width_60" placeholder="Select the rule schedule interval" value="24"/></td>
                           <td class="cr_comm_td"><input type="number" step="1" min="1" max="100" name="learnomatic_rakuten_list[max][]" placeholder="Select the max # of generated posts" value="10" class="cr_width_60"/></td>
                           <td class="cr_status">
                              <select id="submit_status" name="learnomatic_rakuten_list[submit_status][]" class="cr_width_70">
                                 <option value="pending"><?php echo esc_html__("Pending -> Moderate", 'learnomatic-udemy-affiliate-post-generator');?></option>
                                 <option value="draft"><?php echo esc_html__("Draft -> Moderate", 'learnomatic-udemy-affiliate-post-generator');?></option>
                                 <option value="publish" selected><?php echo esc_html__("Published", 'learnomatic-udemy-affiliate-post-generator');?></option>
                                 <option value="private"><?php echo esc_html__("Private", 'learnomatic-udemy-affiliate-post-generator');?></option>
                                 <option value="trash"><?php echo esc_html__("Trash", 'learnomatic-udemy-affiliate-post-generator');?></option>
                              </select>
                           </td>
                           <td class="cr_comm_td"><select id="default_type" name="learnomatic_rakuten_list[default_type][]" class="cr_width_auto">
                              <?php
                                 $is_first = true;
                                 foreach ( get_post_types( '', 'names' ) as $post_type ) {
                                    echo '<option value="' . esc_attr($post_type) . '"';
                                    if($is_first === true)
                                    {
                                        echo ' selected';
                                        $is_first = false;
                                    }
                                    echo '>' . esc_html($post_type) . '</option>';
                                 }
                                 ?>
                              </select>  
                           </td>
                           <td class="cr_author"><select id="post_author" name="learnomatic_rakuten_list[post_author][]" class="cr_width_auto cr_max_width_150">
                              <?php
                                 $blogusers = get_users( [ 'role__in' => [ 'contributor', 'author', 'editor', 'administrator' ] ] );
                                 foreach ($blogusers as $user) {
                                     echo '<option value="' . esc_html($user->ID) . '"';
                                     echo '>' . esc_html($user->display_name) . '</option>';
                                 }
                                 ?>
                              </select>  
                           </td>
                           <td class="cr_width_70">
                              <input type="button" id="mybtnfzr" value="Settings">
                              <div id="mymodalfzr" class="codemodalfzr">
                                 <div class="codemodalfzr-content">
                                    <div class="codemodalfzr-header">
                                       <span id="learnomatic_close" class="codeclosefzr">&times;</span>
                                       <h2><span class="cr_color_white"><?php echo esc_html__("New Rule", 'learnomatic-udemy-affiliate-post-generator');?></span> <?php echo esc_html__("Advanced Settings", 'learnomatic-udemy-affiliate-post-generator');?></h2>
                                    </div>
                                    <div class="codemodalfzr-body">
                                       <div class="table-responsive">
                                          <table class="responsive table cr_main_table_nowr">
                                            <tr><td colspan="2"><h4><?php echo esc_html__("Post Content Customization", 'learnomatic-udemy-affiliate-post-generator');?>:</h4></td></tr>
                                             <tr>
                                                <td class="cr_min_width_200">
                                                   <div>
                                                      <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                         <div class="bws_hidden_help_text cr_min_260px">
                                                            <?php
                                                               echo esc_html__("Set the title of the generated posts for user rules. You can use the following shortcodes: %%random_sentence%%, %%random_sentence2%%, %%item_title%%, %%item_description%%, %%item_content%%, %%item_cat%%, %%item_tags%%", 'learnomatic-udemy-affiliate-post-generator');
                                                               ?>
                                                         </div>
                                                      </div>
                                                      <b><?php echo esc_html__("Generated Post Title:", 'learnomatic-udemy-affiliate-post-generator');?></b>&nbsp;<b><a href="https://coderevolution.ro/knowledge-base/faq/post-template-reference-advanced-usage/" target="_blank">&#9432;</a></b>
                                                </td>
                                                <td>
                                                <input type="text" name="learnomatic_rakuten_list[post_title][]" value="%%item_title%%" placeholder="Please insert your desired post title. Example: %%item_title%%" class="cr_width_full">
                                                </div>
                                                </td>
                                             </tr>
                                             <tr>
                                                <td class="cr_min_width_200">
                                                   <div>
                                                      <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                         <div class="bws_hidden_help_text cr_min_260px">
                                                            <?php
                                                               echo esc_html__("Set the content of the generated posts for user rules. You can use the following shortcodes: %%item_title%%, %%item_content%%, %%item_id%%, %%item_url%%, %%item_content_plain_text%%, %%item_cats%%, %%item_tags%%, %%random_sentence%%, %%random_sentence2%%, %%custom_html%%, %%custom_html2%%, %%item_buy_now_button%%, %%item_show_image%%, %%item_image_URL%%, %%item_description%%, %%item_presentation%%, %%item_description_iframe%%, %%item_price%%, %%item_get_intro%%, %%item_price_currency%%, %%item_price_currency_symbol%%, %%item_price_amount%%, %%item_id_title%%, %%item_predictive_score%%, %%item_curriculum_items%%, %%item_instructor_display_name%%, %%item_instructor_initials%%, %%item_instructor_image%%, %%item_instructor_job_title%%, %%item_instructor_url%%, %%item_instructor_title%%, %%item_instructor_name%%", 'learnomatic-udemy-affiliate-post-generator');
                                                               ?>
                                                         </div>
                                                      </div>
                                                      <b><?php echo esc_html__("Generated Post Content:", 'learnomatic-udemy-affiliate-post-generator');?></b>&nbsp;<b><a href="https://coderevolution.ro/knowledge-base/faq/post-template-reference-advanced-usage/" target="_blank">&#9432;</a></b>
                                                </td>
                                                <td>
                                                <textarea rows="2" cols="70" name="learnomatic_rakuten_list[post_content][]" placeholder="Please insert your desired post content. Example:%%item_content%%" class="cr_width_full">%%item_get_intro%%<br/><br/>%%item_content%%</textarea>
                                                </div></td>
                                             </tr>
                                             <tr>
                                                <td>
                                                   <div>
                                                      <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                         <div class="bws_hidden_help_text cr_min_260px">
                                                            <?php
                                                               echo esc_html__("Do you want to try to get full content for courses? Please note that this feature will not use the API, but will scrape Udemy directly for data.", 'learnomatic-udemy-affiliate-post-generator');
                                                               ?>
                                                         </div>
                                                      </div>
                                                      <b><?php echo esc_html__("Try to Get Full Course Description:", 'learnomatic-udemy-affiliate-post-generator');?></b>
                                                </td>
                                                <td>
                                                <input type="checkbox" id="full_content" name="learnomatic_rakuten_list[full_content][]" checked>
                                                </div>
                                                </td>
                                             </tr>
                                             <tr><td colspan="2"><h4><?php echo esc_html__("Usemy Search Customization", 'learnomatic-udemy-affiliate-post-generator');?>:</h4></td></tr>
                                             <tr>
                                                <td>
                                                   <div>
                                                      <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                         <div class="bws_hidden_help_text cr_min_260px">
                                                            <?php
                                                               echo esc_html__("Select the course language you wish to use.", 'learnomatic-udemy-affiliate-post-generator');
                                                               ?>
                                                         </div>
                                                      </div>
                                                      <b><?php echo esc_html__("Course Language:", 'learnomatic-udemy-affiliate-post-generator');?></b>
                                                </td>
                                                <td>
                                                <select id="language" name="learnomatic_rakuten_list[language][]" class="cr_width_full">
                                                <option  value="any" selected><?php echo esc_html__("Any", 'learnomatic-udemy-affiliate-post-generator');?></option>
                                                <?php
                                                   foreach ($learn_languages as $ltag => $lname) {
                                                   ?>
                                                <option value="<?php
                                                   echo esc_html($ltag);
                                                   ?>"><?php
                                                   echo esc_html($lname);
                                                   ?></option>
                                                <?php
                                                   }
                                                   ?>
                                                </select>
                                                </div>
                                                </td>
                                             </tr>
                                             <tr>
                                                <td>
                                                   <div>
                                                      <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                         <div class="bws_hidden_help_text cr_min_260px">
                                                            <?php
                                                               echo esc_html__("Select the course category you wish to use.", 'learnomatic-udemy-affiliate-post-generator');
                                                               ?>
                                                         </div>
                                                      </div>
                                                      <b><?php echo esc_html__("Course Category:", 'learnomatic-udemy-affiliate-post-generator');?></b>
                                                </td>
                                                <td>
                                                <select id="source" name="learnomatic_rakuten_list[source][]" class="cr_width_full">
                                                <option  value="any" selected><?php echo esc_html__("Any", 'learnomatic-udemy-affiliate-post-generator');?></option>
                                                <option  value="Business" ><?php echo esc_html__("Business", 'learnomatic-udemy-affiliate-post-generator');?></option>
                                                <option  value="Design" ><?php echo esc_html__("Design", 'learnomatic-udemy-affiliate-post-generator');?></option>
                                                <option  value="Development" ><?php echo esc_html__("Development", 'learnomatic-udemy-affiliate-post-generator');?></option>
                                                <option  value="Finance & Accounting" ><?php echo esc_html__("Finance & Accounting", 'learnomatic-udemy-affiliate-post-generator');?></option>
                                                <option  value="Health & Fitness" ><?php echo esc_html__("Health & Fitness", 'learnomatic-udemy-affiliate-post-generator');?></option>
                                                <option  value="IT & Software" ><?php echo esc_html__("IT & Software", 'learnomatic-udemy-affiliate-post-generator');?></option>
                                                <option  value="Lifestyle" ><?php echo esc_html__("Lifestyle", 'learnomatic-udemy-affiliate-post-generator');?></option>
                                                <option  value="Marketing" ><?php echo esc_html__("Marketing", 'learnomatic-udemy-affiliate-post-generator');?></option>
                                                <option  value="Music" ><?php echo esc_html__("Music", 'learnomatic-udemy-affiliate-post-generator');?></option>
                                                <option  value="Office Productivity" ><?php echo esc_html__("Office Productivity", 'learnomatic-udemy-affiliate-post-generator');?></option>
                                                <option  value="Personal Development" ><?php echo esc_html__("Personal Development", 'learnomatic-udemy-affiliate-post-generator');?></option>
                                                <option  value="Photography" ><?php echo esc_html__("Photography", 'learnomatic-udemy-affiliate-post-generator');?></option>
                                                <option  value="Teaching & Academics" ><?php echo esc_html__("Teaching & Academics", 'learnomatic-udemy-affiliate-post-generator');?></option>
                                                </select>
                                                </div>
                                                </td>
                                             </tr>
                                             <tr>
                                                <td>
                                                   <div>
                                                      <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                         <div class="bws_hidden_help_text cr_min_260px">
                                                            <?php
                                                               echo esc_html__("Rank courses by relevance, most-reviewed, highest-rated, newest, price-low-to-high, or price-high-to-low.", 'learnomatic-udemy-affiliate-post-generator');
                                                               ?>
                                                         </div>
                                                      </div>
                                                      <b><?php echo esc_html__("Results Ordering:", 'learnomatic-udemy-affiliate-post-generator');?></b>
                                                </td>
                                                <td>
                                                <select id="ordering" name="learnomatic_rakuten_list[ordering][]" class="cr_width_full">
                                                <option  value="any" selected><?php echo esc_html__("Any", 'learnomatic-udemy-affiliate-post-generator');?></option>
                                                <option  value="retailprice" ><?php echo esc_html__("Price", 'learnomatic-udemy-affiliate-post-generator');?></option>
                                                <option  value="productname" ><?php echo esc_html__("Product Name", 'learnomatic-udemy-affiliate-post-generator');?></option>
                                                <option  value="shortdesp" ><?php echo esc_html__("Product Description", 'learnomatic-udemy-affiliate-post-generator');?></option>
                                                <option  value="categoryname" ><?php echo esc_html__("Category Name", 'learnomatic-udemy-affiliate-post-generator');?></option>
                                                <option  value="mid" ><?php echo esc_html__("Merchant", 'learnomatic-udemy-affiliate-post-generator');?></option>
                                                <option  value="keyword" ><?php echo esc_html__("Keyword", 'learnomatic-udemy-affiliate-post-generator');?></option>
                                                </select>
                                                </div>
                                                </td>
                                             </tr>
                                             <tr>
                                                <td>
                                                   <div>
                                                      <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                         <div class="bws_hidden_help_text cr_min_260px">
                                                            <?php
                                                               echo esc_html__("Do you want to remember last posted item and continue search from it the next time the importing rule runs?", 'learnomatic-udemy-affiliate-post-generator');
                                                               ?>
                                                         </div>
                                                      </div>
                                                      <b><?php echo esc_html__("Cache Items For Continuous Posting (disable to get latest posts only):", 'learnomatic-udemy-affiliate-post-generator');?></b>
                                                </td>
                                                <td>
                                                <input type="checkbox" id="continue_search" name="learnomatic_rakuten_list[continue_search][]" checked>
                                                </div>
                                                </td>
                                             </tr>
                                             <tr><td colspan="2"><h4><?php echo esc_html__("Generated Post Customization", 'learnomatic-udemy-affiliate-post-generator');?>:</h4></td></tr>
                                             <tr>
                                                <td class="cr_min_width_200">
                                                   <div>
                                                      <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                         <div class="bws_hidden_help_text cr_min_260px">
                                                            <?php
                                                               echo esc_html__("If your template supports 'Post Formats', than you can select one here. If not, leave this at it's default value.", 'learnomatic-udemy-affiliate-post-generator');
                                                               ?>
                                                         </div>
                                                      </div>
                                                      <b><?php echo esc_html__("Generated Post Format:", 'learnomatic-udemy-affiliate-post-generator');?></b>   
                                                </td>
                                                <td class="cr_min_width_200">
                                                <select id="post_format" name="learnomatic_rakuten_list[post_format][]" class="cr_width_full">
                                                <option value="post-format-standard"  selected><?php echo esc_html__("Standard", 'learnomatic-udemy-affiliate-post-generator');?></option>
                                                <option value="post-format-aside"><?php echo esc_html__("Aside", 'learnomatic-udemy-affiliate-post-generator');?></option>
                                                <option value="post-format-gallery"><?php echo esc_html__("Gallery", 'learnomatic-udemy-affiliate-post-generator');?></option>
                                                <option value="post-format-link"><?php echo esc_html__("Link", 'learnomatic-udemy-affiliate-post-generator');?></option>
                                                <option value="post-format-image"><?php echo esc_html__("Image", 'learnomatic-udemy-affiliate-post-generator');?></option>
                                                <option value="post-format-quote"><?php echo esc_html__("Quote", 'learnomatic-udemy-affiliate-post-generator');?></option>
                                                <option value="post-format-status"><?php echo esc_html__("Status", 'learnomatic-udemy-affiliate-post-generator');?></option>
                                                <option value="post-format-video"><?php echo esc_html__("Video", 'learnomatic-udemy-affiliate-post-generator');?></option>
                                                <option value="post-format-audio"><?php echo esc_html__("Audio", 'learnomatic-udemy-affiliate-post-generator');?></option>
                                                <option value="post-format-chat"><?php echo esc_html__("Chat", 'learnomatic-udemy-affiliate-post-generator');?></option>
                                                </select>     
                                                </div>
                                                </td>
                                             </tr>
                                             <tr>
                                                <td class="cr_min_width_200">
                                                   <div>
                                                      <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                         <div class="bws_hidden_help_text cr_min_260px">
                                                            <?php
                                                               echo esc_html__("Select the post category that you want for the automatically generated posts to have.", 'learnomatic-udemy-affiliate-post-generator');
                                                               ?>
                                                         </div>
                                                      </div>
                                                      <b><?php echo esc_html__("Additional Post Category:", 'learnomatic-udemy-affiliate-post-generator');?></b>
                                                </td>
                                                <td>
                                                <select id="default_category" name="learnomatic_rakuten_list[default_category][]" class="cr_width_full">
                                                <option value="learnomatic_no_category_12345678" selected><?php echo esc_html__("Do Not Add a Category", 'learnomatic-udemy-affiliate-post-generator');?></option>
                                                <?php
                                                   $cat_args   = array(
                                                       'orderby' => 'name',
                                                       'hide_empty' => 0,
                                                       'order' => 'ASC'
                                                   );
                                                   $categories = get_categories($cat_args);
                                                   foreach ($categories as $category) {
                                                   ?>
                                                <option value="<?php
                                                   echo esc_html($category->term_id);
                                                   ?>"><?php
                                                   echo esc_html(sanitize_text_field($category->name));
                                                   ?></option>
                                                <?php
                                                   }
                                                   ?>
                                                </select>     
                                                </div>
                                                </td>
                                             </tr>
                                             <tr>
                                                <td>
                                                   <div>
                                                      <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                         <div class="bws_hidden_help_text cr_min_260px">
                                                            <?php
                                                               echo esc_html__("Do you want to automatically add post categories from the Udemy items?", 'learnomatic-udemy-affiliate-post-generator');
                                                               ?>
                                                         </div>
                                                      </div>
                                                      <b><?php echo esc_html__("Auto Add Categories:", 'learnomatic-udemy-affiliate-post-generator');?></b>
                                                </td>
                                                <td>
                                                <select class="cr_width_full" id="auto_categories" name="learnomatic_rakuten_list[auto_categories][]">
                                                <option value="disabled" selected><?php echo esc_html__("Disabled", 'learnomatic-udemy-affiliate-post-generator');?></option>
                                                <option value="title"><?php echo esc_html__("Title", 'learnomatic-udemy-affiliate-post-generator');?></option>
                                                <option value="coursep"><?php echo esc_html__("Course Primary Category", 'learnomatic-udemy-affiliate-post-generator');?></option>
                                                <option value="courses"><?php echo esc_html__("Course Secondary Category", 'learnomatic-udemy-affiliate-post-generator');?></option>
                                                <option value="course"><?php echo esc_html__("Course Primary & Secondary Category", 'learnomatic-udemy-affiliate-post-generator');?></option>
                                                </select>   
                                                </div>
                                                </td>
                                             </tr>
                                             <tr>
                                                <td>
                                                   <div>
                                                      <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                         <div class="bws_hidden_help_text cr_min_260px">
                                                            <?php
                                                               echo esc_html__("This feature will try to remove the WordPress's default post category. This may fail in case no additional categories are added, because WordPress requires at least one post category for every post.", 'learnomatic-udemy-affiliate-post-generator');
                                                               ?>
                                                         </div>
                                                      </div>
                                                      <b><?php echo esc_html__("Remove WP Default Post Category:", 'learnomatic-udemy-affiliate-post-generator');?></b>
                                                </td>
                                                <td>
                                                <input type="checkbox" id="remove_default" name="learnomatic_rakuten_list[remove_default][]" checked>
                                                </div>
                                                </td>
                                             </tr>
                                             <tr>
                                                <td>
                                                   <div>
                                                      <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                         <div class="bws_hidden_help_text cr_min_260px">
                                                            <?php
                                                               echo esc_html__("Do you want to automatically add post tags from the Udemy items?", 'learnomatic-udemy-affiliate-post-generator');
                                                               ?>
                                                         </div>
                                                      </div>
                                                      <b><?php echo esc_html__("Auto Add Tags:", 'learnomatic-udemy-affiliate-post-generator');?></b>
                                                </td>
                                                <td>
                                                <select class="cr_width_full" id="auto_tags" name="learnomatic_rakuten_list[auto_tags][]">
                                                <option value="disabled" selected><?php echo esc_html__("Disabled", 'learnomatic-udemy-affiliate-post-generator');?></option>
                                                <option value="title"><?php echo esc_html__("Title", 'learnomatic-udemy-affiliate-post-generator');?></option>
                                                <option value="coursep"><?php echo esc_html__("Course Primary Category", 'learnomatic-udemy-affiliate-post-generator');?></option>
                                                <option value="courses"><?php echo esc_html__("Course Secondary Category", 'learnomatic-udemy-affiliate-post-generator');?></option>
                                                <option value="course"><?php echo esc_html__("Course Primary & Secondary Category", 'learnomatic-udemy-affiliate-post-generator');?></option>
                                                </select> 
                                                </div>
                                                </td>
                                             </tr>
                                             <tr>
                                                <td>
                                                   <div>
                                                      <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                         <div class="bws_hidden_help_text cr_min_260px">
                                                            <?php
                                                               echo esc_html__("Select the post tags that you want for the automatically generated posts to have.", 'learnomatic-udemy-affiliate-post-generator');
                                                               ?>
                                                         </div>
                                                      </div>
                                                      <b><?php echo esc_html__("Additional Post Tags:", 'learnomatic-udemy-affiliate-post-generator');?></b>
                                                </td>
                                                <td>
                                                <input type="text" name="learnomatic_rakuten_list[default_tags][]" value="" placeholder="Please insert your additional post tags here" class="cr_width_full">
                                                </div>
                                                </td>
                                             </tr>
                                             <tr>
                                                <td>
                                                   <div>
                                                      <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                         <div class="bws_hidden_help_text cr_min_260px">
                                                            <?php
                                                               echo esc_html__("Do you want to limit the title's length to a specific word count? To disable this feature, leave this field blank.", 'learnomatic-udemy-affiliate-post-generator');
                                                               ?>
                                                         </div>
                                                      </div>
                                                      <b><?php echo esc_html__("Limit Title Word Count:", 'learnomatic-udemy-affiliate-post-generator');?></b>
                                                </td>
                                                <td>
                                                <input type="number" min="1" step="1" id="limit_title_word_count" name="learnomatic_rakuten_list[limit_title_word_count][]" value="" placeholder="Please insert a limit for title" class="cr_width_full">
                                                </div>
                                                </td>
                                             </tr>
                                             <tr>
                                                <td>
                                                   <div>
                                                      <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                         <div class="bws_hidden_help_text cr_min_260px">
                                                            <?php
                                                               echo esc_html__("Do you want to limit the content's length to a specific word count? To disable this feature, leave this field blank.", 'learnomatic-udemy-affiliate-post-generator');
                                                               ?>
                                                         </div>
                                                      </div>
                                                      <b><?php echo esc_html__("Limit Content Word Count:", 'learnomatic-udemy-affiliate-post-generator');?></b>
                                                </td>
                                                <td>
                                                <input type="number" min="1" step="1" id="limit_content_word_count" name="learnomatic_rakuten_list[limit_content_word_count][]" value="" placeholder="Please insert a limit for content" class="cr_width_full">
                                                </div>
                                                </td>
                                             </tr>
                                             <tr>
                                                <td>
                                                   <div>
                                                      <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                         <div class="bws_hidden_help_text cr_min_260px">
                                                            <?php
                                                               echo esc_html__("Make permalinks (title and image) link directly to the post's source url. Warning: posts will not load at your site!", 'learnomatic-udemy-affiliate-post-generator');
                                                               ?>
                                                         </div>
                                                      </div>
                                                      <b><?php echo esc_html__("Permalinks Link To Source:", 'learnomatic-udemy-affiliate-post-generator');?></b>
                                                </td>
                                                <td>
                                                <input type="checkbox" id="title_link" name="learnomatic_rakuten_list[title_link][]">
                                                </div>
                                                </td>
                                             </tr>
                                             <tr>
                                                <td>
                                                   <div>
                                                      <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                         <div class="bws_hidden_help_text cr_min_260px">
                                                            <?php
                                                               echo esc_html__("Do you want to link post images to original article source?", 'learnomatic-udemy-affiliate-post-generator');
                                                               ?>
                                                         </div>
                                                      </div>
                                                      <b><?php echo esc_html__("Link Post Images To Source:", 'learnomatic-udemy-affiliate-post-generator');?></b>
                                                </td>
                                                <td>
                                                <input type="checkbox" id="add_link_img" name="learnomatic_rakuten_list[add_link_img][]">
                                                </div>
                                                </td>
                                             </tr>
                                             <tr>
                                                <td>
                                                   <div>
                                                      <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                         <div class="bws_hidden_help_text cr_min_260px">
                                                            <?php
                                                               echo esc_html__("Do you want to enable comments for the generated posts?", 'learnomatic-udemy-affiliate-post-generator');
                                                               ?>
                                                         </div>
                                                      </div>
                                                      <b><?php echo esc_html__("Enable Comments For Posts:", 'learnomatic-udemy-affiliate-post-generator');?></b>
                                                </td>
                                                <td>
                                                <input type="checkbox" id="enable_comments" name="learnomatic_rakuten_list[enable_comments][]" checked>
                                                </div>
                                                </td>
                                             </tr>
                                             <tr>
                                                <td>
                                                   <div>
                                                      <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                         <div class="bws_hidden_help_text cr_min_260px">
                                                            <?php
                                                               echo esc_html__("Do you want to enable pingbacks/trackbacks for the generated posts?", 'learnomatic-udemy-affiliate-post-generator');
                                                               ?>
                                                         </div>
                                                      </div>
                                                      <b><?php echo esc_html__("Enable Pingback/Trackback:", 'learnomatic-udemy-affiliate-post-generator');?></b>
                                                </td>
                                                <td>
                                                <input type="checkbox" id="enable_pingback" name="learnomatic_rakuten_list[enable_pingback][]" checked>
                                                </div>
                                                </td>
                                             </tr>
                                             <tr>
                                                <td>
                                                   <div>
                                                      <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                         <div class="bws_hidden_help_text cr_min_260px">
                                                            <?php
                                                               echo esc_html__("Do you want to set featured image for generated post (to the first image that was found in the post)?", 'learnomatic-udemy-affiliate-post-generator');
                                                               ?>
                                                         </div>
                                                      </div>
                                                      <b><?php echo esc_html__("Auto Get Featured Image:", 'learnomatic-udemy-affiliate-post-generator');?></b>
                                                </td>
                                                <td>
                                                <input type="checkbox" id="featured_image" name="learnomatic_rakuten_list[featured_image][]" checked>
                                                </div>
                                                </td>
                                             </tr>
                                             <tr>
                                                <td>
                                                   <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                      <div class="bws_hidden_help_text cr_min_260px">
                                                         <?php
                                                            echo esc_html__("Insert a comma separated list of links to valid images that will be set randomly for the featured image for the posts that do not have a valid image attached or if you disabled automatical featured image generation. You can also use image numeric IDs from images found in the Media Gallery. To disable this feature, leave this field blank.", 'learnomatic-udemy-affiliate-post-generator');
                                                            ?>
                                                      </div>
                                                   </div>
                                                   <b><?php echo esc_html__("Default Featured Image List:", 'learnomatic-udemy-affiliate-post-generator');?></b>
                                                </td>
                                                <td>
                                                   <input class="cr_width_60p" type="text" name="learnomatic_rakuten_list[image_url][]" placeholder="Please insert the link to a valid image" id="cr_input_box"  value=""/>
                                                   <input class="cr_width_33p learnomatic_image_button" type="button" value=">>>"/>
                                                </td>
                                             </tr>
                                             <tr>
                                                <td class="cr_min_width_200">
                                                   <div>
                                                      <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                         <div class="bws_hidden_help_text cr_min_260px">
                                                            <?php
                                                               echo esc_html__("Set the custom fields that will be set for generated posts. The syntax for this field is the following: custom_field_name1 => custom_field_value1, custom_field_name2 => custom_field_value2, ... . In custom_field_valueX, you can use shortcodes, same like in post content. You can also assign the data to array custom fields, using this format: array_field[index_name1] => custom_field_value1, array_field[index_name2] => custom_field_value2. Example (without quotes): 'title_custom_field => %%item_title%%'. You can use the following shortcodes: %%item_title%%, %%item_content%%, %%item_id%%, %%item_url%%, %%item_content_plain_text%%, %%item_cats%%, %%item_tags%%, %%random_sentence%%, %%random_sentence2%%, %%custom_html%%, %%custom_html2%%, %%item_buy_now_button%%, %%item_show_image%%, %%item_image_URL%%, %%item_description%%, %%item_presentation%%, %%item_description_iframe%%, %%item_price%%, %%item_get_intro%%, %%item_price_currency%%, %%item_price_currency_symbol%%, %%item_price_amount%%, %%item_id_title%%, %%item_predictive_score%%, %%item_curriculum_items%%, %%item_instructor_display_name%%, %%item_instructor_initials%%, %%item_instructor_image%%, %%item_instructor_job_title%%, %%item_instructor_url%%, %%item_instructor_title%%, %%item_instructor_name%%", 'learnomatic-udemy-affiliate-post-generator');
                                                               ?>
                                                         </div>
                                                      </div>
                                                      <b><?php echo esc_html__("Post Custom Fields:", 'learnomatic-udemy-affiliate-post-generator');?></b>&nbsp;<b><a href="https://coderevolution.ro/knowledge-base/faq/post-template-reference-advanced-usage/" target="_blank">&#9432;</a></b>
                                                </td>
                                                <td>
                                                <textarea rows="1" cols="70" name="learnomatic_rakuten_list[custom_fields][]" placeholder="Please insert your desired custom fields. Example: title_custom_field => %%item_title%%" class="cr_width_full"></textarea>
                                                </div>
                                                </td>
                                             </tr>
                                             <tr>
                                                <td class="cr_min_width_200">
                                                   <div>
                                                      <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                                         <div class="bws_hidden_help_text cr_min_260px">
                                                            <?php
                                                               echo esc_html__("Set the custom taxonomies that will be set for generated posts. The syntax for this field is the following: custom_taxonomy_name1 => custom_taxonomy_value1A, custom_taxonomy_value1B; custom_taxonomy_name2 => custom_taxonomy_value2A, custom_taxonomy_value2B; ... . In custom_taxonomy_valueX, you can use shortcodes. Example (without quotes): 'cats_taxonomy_field => manualtax1, %%item_tags%%; tags_taxonomy_field => manualtax2, %%item_tags%%'. You can use the following shortcodes: %%item_title%%, %%item_content%%, %%item_id%%, %%item_url%%, %%item_content_plain_text%%, %%item_cats%%, %%item_tags%%, %%random_sentence%%, %%random_sentence2%%, %%custom_html%%, %%custom_html2%%, %%item_buy_now_button%%, %%item_show_image%%, %%item_image_URL%%, %%item_description%%, %%item_presentation%%, %%item_description_iframe%%, %%item_price%%, %%item_get_intro%%, %%item_price_currency%%, %%item_price_currency_symbol%%, %%item_price_amount%%, %%item_id_title%%, %%item_predictive_score%%, %%item_curriculum_items%%, %%item_instructor_display_name%%, %%item_instructor_initials%%, %%item_instructor_image%%, %%item_instructor_job_title%%, %%item_instructor_url%%, %%item_instructor_title%%, %%item_instructor_name%%. If you defined custom tag names in the 'Feed Item Custom Tag Names' settings field in plugin's 'Main Settings', you will also be able to use a shortcode for each inserted field name, in this format: %%custom_*field_name*%%", 'learnomatic-udemy-affiliate-post-generator');
                                                               ?>
                                                         </div>
                                                      </div>
                                                      <b><?php echo esc_html__("Post Custom Taxonomies:", 'learnomatic-udemy-affiliate-post-generator');?></b>&nbsp;<b><a href="https://coderevolution.ro/knowledge-base/faq/post-template-reference-advanced-usage/" target="_blank">&#9432;</a></b>
                                                </td>
                                                <td>
                                                <textarea rows="1" cols="70" name="learnomatic_rakuten_list[custom_tax][]" placeholder="Please insert your desired custom taxonomies. Example: custom_taxonomy_name => %%item_cats%%" class="cr_width_full"></textarea>
                                                </div>
                                                </td>
                                             </tr>
                                          </table>
                                       </div>
                                    </div>
                                    <div class="codemodalfzr-footer">
                                       <br/>
                                       <h3 class="cr_inline">Learnomatic Udemy Affiliate Post Generator</h3>
                                       <span id="learnomatic_ok" class="codeokfzr cr_inline">OK&nbsp;</span>
                                       <br/><br/>
                                    </div>
                                 </div>
                              </div>
                           </td>
                           <td class="cr_shrt_td2"><span class="cr_gray20">X</span></td>
                           <td class="cr_short_td"><input type="checkbox" name="learnomatic_rakuten_list[active][]" value="1" checked />
                              <input type="hidden" name="learnomatic_rakuten_list[last_run][]" value="1988-01-27 00:00:00"/>
                           </td>
                           <td class="cr_short_td">
                              <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                 <div class="bws_hidden_help_text cr_min_260px">
                                    <?php
                                       echo esc_html__("No info.", 'learnomatic-udemy-affiliate-post-generator');
                                       ?>
                                 </div>
                              </div>
                           </td>
                           <td class="cr_center">
                              <div>
                                 <img src="<?php
                                    echo esc_url(plugin_dir_url(dirname(__FILE__)) . 'images/running.gif');
                                    ?>" alt="Running" class="cr_running">
                                 <div class="codemainfzr cr_gray_back">
                                    <select id="actions" class="actions" name="actions" disabled>
                                       <option value="select" disabled selected><?php echo esc_html__("Select an Action", 'learnomatic-udemy-affiliate-post-generator');?></option>
                                       <option value="run" onclick=""><?php echo esc_html__("Run This Rule Now", 'learnomatic-udemy-affiliate-post-generator');?></option>
                                       <option value="trash" onclick=""><?php echo esc_html__("Move All Posts To Trash", 'learnomatic-udemy-affiliate-post-generator');?></option>
                                       <option value="duplicate" onclick=""><?php echo esc_html__("Duplicate This Rule", 'learnomatic-udemy-affiliate-post-generator');?></option>
                                       <option value="delete" onclick=""><?php echo esc_html__("Permanently Delete All Posts", 'learnomatic-udemy-affiliate-post-generator');?></option>
                                    </select>
                                 </div>
                              </div>
                           </td>
                        </tr>
                     </tbody>
                  </table>
               </div>
            </div>
         </div>
         <hr/>
         <div>
            <p class="submit"><input type="submit" name="btnSubmit" id="btnSubmit" class="button button-primary" onclick="unsaved = false;" value="<?php echo esc_html__("Save Settings", 'learnomatic-udemy-affiliate-post-generator');?>"/></p>
         </div>
         <div>
            <?php echo esc_html__("New! AI generated shortcodes supported, click for details:", 'learnomatic-udemy-affiliate-post-generator');?>&nbsp;<a href="https://coderevolution.ro/knowledge-base/faq/how-to-create-ai-generated-content-from-any-plugin-built-by-coderevolution/" target="_blank"><img src="https://i.ibb.co/gvTNWr6/artificial-intelligence-badge.png" alt="artificial-intelligence-badge" title="AI content generator support, when used together with the Aiomatic plugin"></a><br/><br/><a href="https://www.youtube.com/watch?v=5rbnu_uis7Y" target="_blank"><?php echo esc_html__("Nested Shortcodes also supported!", 'learnomatic-udemy-affiliate-post-generator');?></a><br/><?php echo esc_html__("Confused about rule running status icons?", 'learnomatic-udemy-affiliate-post-generator');?> <a href="http://coderevolution.ro/knowledge-base/faq/how-to-interpret-the-rule-running-visual-indicators-red-x-yellow-diamond-green-tick-from-inside-plugins/" target="_blank"><?php echo esc_html__("More info", 'learnomatic-udemy-affiliate-post-generator');?></a><br/>
            <div class="cr_none" id="midas_icons">
               <table>
                  <tr>
                     <td><img id="run_img" src="<?php echo esc_url(plugin_dir_url(dirname(__FILE__)) . 'images/running.gif');?>" alt="Running" title="status"></td>
                     <td><?php echo esc_html__("In Progress", 'learnomatic-udemy-affiliate-post-generator');?> - <b><?php echo esc_html__("Importing is Running", 'learnomatic-udemy-affiliate-post-generator');?></b></td>
                  </tr>
                  <tr>
                     <td><img id="ok_img" src="<?php echo esc_url(plugin_dir_url(dirname(__FILE__)) . 'images/ok.gif');?>" alt="OK"  title="status"></td>
                     <td><?php echo esc_html__("Success", 'learnomatic-udemy-affiliate-post-generator');?> - <b><?php echo esc_html__("New Posts Created", 'learnomatic-udemy-affiliate-post-generator');?></b></td>
                  </tr>
                  <tr>
                     <td><img id="fail_img" src="<?php echo esc_url(plugin_dir_url(dirname(__FILE__)) . 'images/failed.gif');?>" alt="Faield" title="status"></td>
                     <td><?php echo esc_html__("Failed", 'learnomatic-udemy-affiliate-post-generator');?> - <b><?php echo esc_html__("An Error Occurred.", 'learnomatic-udemy-affiliate-post-generator');?> <b><?php echo esc_html__("Please check 'Activity and Logging' plugin menu for details.", 'learnomatic-udemy-affiliate-post-generator');?></b></td>
                  </tr>
                  <tr>
                     <td><img id="nochange_img" src="<?php echo esc_url(plugin_dir_url(dirname(__FILE__)) . 'images/nochange.gif');?>" alt="NoChange" title="status"></td>
                     <td><?php echo esc_html__("No Change - No New Posts Created", 'learnomatic-udemy-affiliate-post-generator');?> - <b><?php echo esc_html__("Possible reasons:", 'learnomatic-udemy-affiliate-post-generator');?></b></td>
                  </tr>
                  <tr>
                     <td></td>
                     <td>
                        <ul>
                           <li>&#9658; <?php echo esc_html__("Already all posts are published that match your search and posts will be posted when new content will be available", 'learnomatic-udemy-affiliate-post-generator');?></li>
                           <li>&#9658; <?php echo esc_html__("Some restrictions you defined in the plugin's 'Main Settings'", 'learnomatic-udemy-affiliate-post-generator');?> <i>(<?php echo esc_html__("example: 'Minimum Content Word Count', 'Maximum Content Word Count', 'Minimum Title Word Count', 'Maximum Title Word Count', 'Banned Words List', 'Reuired Words List', 'Skip Posts Without Images'", 'learnomatic-udemy-affiliate-post-generator');?>)</i> <?php echo esc_html__("prevent posting of new posts.", 'learnomatic-udemy-affiliate-post-generator');?></li>
                        </ul>
                     </td>
                  </tr>
               </table>
            </div>
         </div>
         <?php
         }
         ?>
      </form>
   </div>
</div>
<?php
   }
   if (isset($_POST['learnomatic_rakuten_list'])) {
       add_action('admin_init', 'learnomatic_save_rules_rakuten');
   }
   
   function learnomatic_save_rules_rakuten($data2)
   {
       check_admin_referer('learnomatic_save_rules', '_learnomaticr_nonce');
       
       $data2 = $_POST['learnomatic_rakuten_list'];
       $rules = array();
       $cont  = 0;
       if (isset($data2['rule_keywords'][0])) {
           for ($i = 0; $i < sizeof($data2['rule_keywords']); ++$i) {
               $bundle = array();
               if (isset($data2['schedule'][$i]) && $data2['schedule'][$i] != '' && $data2['rule_keywords'][$i] != '') {
                   $bundle[] = trim(sanitize_text_field($data2['schedule'][$i]));
                   if (isset($data2['active'][$i])) {
                       $bundle[] = trim(sanitize_text_field($data2['active'][$i]));
                   } else {
                       $bundle[] = '0';
                   }
                   $bundle[]     = trim(sanitize_text_field($data2['last_run'][$i]));
                   $bundle[]     = trim(sanitize_text_field($data2['max'][$i]));
                   $bundle[]     = trim(sanitize_text_field($data2['submit_status'][$i]));
                   $bundle[]     = trim(sanitize_text_field($data2['default_type'][$i]));
                   $bundle[]     = trim(sanitize_text_field($data2['post_author'][$i]));
                   $bundle[]     = trim(sanitize_text_field($data2['default_tags'][$i]));
                   $bundle[]     = trim(sanitize_text_field($data2['default_category'][$i]));
                   $bundle[]     = trim(sanitize_text_field($data2['auto_categories'][$i]));
                   $bundle[]     = trim(sanitize_text_field($data2['auto_tags'][$i]));
                   $bundle[]     = trim(sanitize_text_field($data2['enable_comments'][$i]));
                   $bundle[]     = trim(sanitize_text_field($data2['featured_image'][$i]));
                   $bundle[]     = trim($data2['image_url'][$i]);
                   $bundle[]     = $data2['post_title'][$i];
                   $bundle[]     = $data2['post_content'][$i];
                   $bundle[]     = trim(sanitize_text_field($data2['enable_pingback'][$i]));
                   $bundle[]     = trim(sanitize_text_field($data2['post_format'][$i]));
                   $bundle[]     = trim(sanitize_text_field($data2['rule_keywords'][$i]));
                   $bundle[]     = trim($data2['custom_fields'][$i]);
                   $bundle[]     = trim(sanitize_text_field($data2['title_link'][$i]));
                   $bundle[]     = trim(sanitize_text_field($data2['add_link_img'][$i]));
                   $bundle[]     = trim(sanitize_text_field($data2['remove_default'][$i]));
                   $bundle[]     = trim(sanitize_text_field($data2['continue_search'][$i]));
                   $bundle[]     = trim($data2['custom_tax'][$i]);
                   $bundle[]     = trim(sanitize_text_field($data2['limit_title_word_count'][$i]));
                   $bundle[]     = trim(sanitize_text_field($data2['limit_content_word_count'][$i]));
                   $bundle[]     = trim(sanitize_text_field($data2['source'][$i]));
                   $bundle[]     = trim(sanitize_text_field($data2['language'][$i]));
                   $bundle[]     = trim(sanitize_text_field($data2['ordering'][$i]));
                   $bundle[]     = trim(sanitize_text_field($data2['full_content'][$i]));
                   $rules[$cont] = $bundle;
                   $cont++;
               }
           }
       }
       update_option('learnomatic_rakuten_list', $rules, false);
   }
   function learnomatic_expand_rules_rakuten($learn_languages)
   {
       $cat_args   = array(
                   "orderby" => "name",
                   "hide_empty" => 0,
                   "order" => "ASC"
       );
       $categories = get_categories($cat_args);
       if (!get_option('learnomatic_running_list')) {
           $running = array();
       } else {
           $running = get_option('learnomatic_running_list');
       }
       $GLOBALS['wp_object_cache']->delete('learnomatic_rakuten_list', 'options');
       $rules  = get_option('learnomatic_rakuten_list');
    if(!is_array($rules))
    {
       $rules = array();
    }
       $output = '';
       $cont   = 0;
       if (!empty($rules)) {
           $learnomatic_Main_Settings = get_option('learnomatic_Main_Settings', false);
           if (isset($learnomatic_Main_Settings['no_check']) && $learnomatic_Main_Settings['no_check'] == 'on')
           {
               $counted_vals = array();
           }
           else
           {
               $posted_items = array();
               $post_list = array();
               $postsPerPage = 50000;
               $paged = 0;
               do
               {
                   $postOffset = $paged * $postsPerPage;
                   $query = array(
                       'post_status' => array(
                           'publish',
                           'draft',
                           'pending',
                           'trash',
                           'private',
                           'future'
                       ),
                       'post_type' => array(
                           'any'
                       ),
                       'numberposts' => $postsPerPage,
                       'meta_key' => 'learnomatic_parent_rule',
                       'fields' => 'ids',
                       'offset'  => $postOffset
                   );
                   $got_me = get_posts($query);
                   $post_list = array_merge($post_list, $got_me);
                   $paged++;
               }while(!empty($got_me));
               wp_suspend_cache_addition(true);
               foreach ($post_list as $post) {
                   $rule_id = get_post_meta($post, 'learnomatic_parent_rule', true);
                   $rule_type = get_post_meta($post, 'learnomatic_parent_type', true);
                   if ($rule_id != '' && $rule_type == '1') {
                       $posted_items[] = $rule_id;
                   }
               }
               wp_suspend_cache_addition(false);
               $counted_vals = array_count_values($posted_items);
           }
           foreach ($rules as $request => $bundle[]) {
               if (isset($counted_vals[$cont])) {
                   $generated_posts = $counted_vals[$cont];
               } else {
                   $generated_posts = 0;
               }
               $bundle_values          = array_values($bundle);
               $myValues               = $bundle_values[$cont];
               $array_my_values        = array_values($myValues);for($iji=0;$iji<count($array_my_values);++$iji){if(is_string($array_my_values[$iji])){$array_my_values[$iji]=stripslashes($array_my_values[$iji]);}}
               $schedule               = $array_my_values[0];
               $active                 = $array_my_values[1];
               $last_run               = $array_my_values[2];
               $max                    = $array_my_values[3];
               $status                 = $array_my_values[4];
               $def_type               = $array_my_values[5];
               $post_user_name         = $array_my_values[6];
               $default_tags           = $array_my_values[7];
               $default_category       = $array_my_values[8];
               $auto_categories        = $array_my_values[9];
               $auto_tags              = $array_my_values[10];
               $enable_comments        = $array_my_values[11];
               $featured_image         = $array_my_values[12];
               $image_url              = $array_my_values[13];
               $post_title             = $array_my_values[14];
               $post_content           = $array_my_values[15];
               $enable_pingback        = $array_my_values[16];
               $post_format            = $array_my_values[17];
               $rule_keywords          = $array_my_values[18];
               $custom_fields          = $array_my_values[19];
               $title_link             = $array_my_values[20];
               $add_link_img           = $array_my_values[21];
               $remove_default         = $array_my_values[22];
               $continue_search        = $array_my_values[23];
               $custom_tax             = $array_my_values[24];
               $limit_title_word_count = $array_my_values[25];
               $limit_content_word_count= $array_my_values[26];
               $source                 = $array_my_values[27];
               $language               = $array_my_values[28];
               $ordering               = $array_my_values[29];
               $full_content           = $array_my_values[30];
               wp_add_inline_script('learnomatic-footer-script', 'createAdmin(' . esc_html($cont) . ');', 'after');
               $output .= '<tr>
                           <td class="cr_short_td">' . esc_html($cont) . '</td>
                           <td class="cr_select_option"><input type="text" name="learnomatic_rakuten_list[rule_keywords][]" placeholder="Please input your search keywords" value="' . esc_attr($rule_keywords) . '" class="cr_width_full"/></td> </td>
   						<td class="cr_comm_td"><input type="number" step="1" min="1" placeholder="# h" name="learnomatic_rakuten_list[schedule][]" max="8765812" value="' . esc_attr($schedule) . '" class="cr_width_60" required></td>
                           <td class="cr_comm_td"><input type="number" step="1" min="0" placeholder="# max" max="100" name="learnomatic_rakuten_list[max][]" value="' . esc_attr($max) . '"  class="cr_width_60" required></td>
                           <td class="cr_status"><select id="submit_status" name="learnomatic_rakuten_list[submit_status][]" class="cr_width_70">
                                     <option value="pending"';
               if ($status == 'pending') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("Pending -> Moderate", 'learnomatic-udemy-affiliate-post-generator') . '</option>
                                     <option value="draft"';
               if ($status == 'draft') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("Draft -> Moderate", 'learnomatic-udemy-affiliate-post-generator') . '</option>
                                     <option value="publish"';
               if ($status == 'publish') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("Published", 'learnomatic-udemy-affiliate-post-generator') . '</option>
                                     <option value="private"';
               if ($status == 'private') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("Private", 'learnomatic-udemy-affiliate-post-generator') . '</option>
                                     <option value="trash"';
               if ($status == 'trash') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("Trash", 'learnomatic-udemy-affiliate-post-generator') . '</option>
                       </select>  </td>
                       <td class="cr_comm_td"><select id="default_type" name="learnomatic_rakuten_list[default_type][]" class="cr_width_auto">';
               foreach ( get_post_types( '', 'names' ) as $post_type ) {
                  $output .= '<option value="' . esc_attr($post_type) . '"';
                  if ($def_type == $post_type) {
                       $output .= ' selected';
                   }
                  $output .= '>' . esc_html($post_type) . '</option>';
               }
                       $output .= '</select>  </td>
                       <td class="cr_author"><select id="post_author" name="learnomatic_rakuten_list[post_author][]" class="cr_width_auto cr_max_width_150">';
               $blogusers = get_users( [ 'role__in' => [ 'contributor', 'author', 'editor', 'administrator' ] ] );
               foreach ($blogusers as $user) {
                   $output .= '<option value="' . esc_html($user->ID) . '"';
                   if ($post_user_name == $user->ID) {
                       $output .= " selected";
                   }
                   $output .= '>' . esc_html($user->display_name) . '</option>';
               }
               $output .= '</select>  </td>
                       <td class="cr_width_70">
                       <input type="button" id="mybtnfzr' . esc_html($cont) . '" value="Settings">
                       <div id="mymodalfzr' . esc_html($cont) . '" class="codemodalfzr">
     <div class="codemodalfzr-content">
       <div class="codemodalfzr-header">
         <span id="learnomatic_close' . esc_html($cont) . '" class="codeclosefzr">&times;</span>
         <h2>' . esc_html__('Rule', 'learnomatic-udemy-affiliate-post-generator') . ' <span class="cr_color_white">ID ' . esc_html($cont) . '</span> ' . esc_html__('Advanced Settings', 'learnomatic-udemy-affiliate-post-generator') . '</h2>
       </div>
       <div class="codemodalfzr-body">
       <div class="table-responsive">
         <table class="responsive table cr_main_table_nowr">
         <tr><td colspan="2"><h4>' . esc_html__("Post Content Customization", 'learnomatic-udemy-affiliate-post-generator') . ':</h4></td></tr>
       <tr><td class="cr_min_width_200">
       <div>
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text cr_min_260px">' . esc_html__("Set the title of the generated posts for user rules. You can use the following shortcodes:  %%random_sentence%%, %%random_sentence2%%, %%item_title%%, %%item_description%%, %%item_content%%, %%item_cat%%, %%item_tags%%", 'learnomatic-udemy-affiliate-post-generator') . '
                           </div>
                       </div>
                       <b>' . esc_html__("Generated Post Title", 'learnomatic-udemy-affiliate-post-generator') . ':</b>&nbsp;<b><a href="https://coderevolution.ro/knowledge-base/faq/post-template-reference-advanced-usage/" target="_blank">&#9432;</a></b>
                       
                       </td><td>
                       <input type="text" name="learnomatic_rakuten_list[post_title][]" value="' . esc_attr(htmlspecialchars($post_title)) . '" placeholder="Please insert your desired post title. Example: %%item_title%%" class="cr_width_full">
                           
           </div>
           </td></tr><tr><td class="cr_min_width_200">
           <div>
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text cr_min_260px">' . esc_html__("Set the content of the generated posts for user rules. You can use the following shortcodes: %%item_title%%, %%item_content%%, %%item_id%%, %%item_url%%, %%item_content_plain_text%%, %%item_cats%%, %%item_tags%%, %%random_sentence%%, %%random_sentence2%%, %%custom_html%%, %%custom_html2%%, %%item_buy_now_button%%, %%item_show_image%%, %%item_image_URL%%, %%item_description%%, %%item_presentation%%, %%item_description_iframe%%, %%item_price%%, %%item_get_intro%%, %%item_price_currency%%, %%item_price_currency_symbol%%, %%item_price_amount%%, %%item_id_title%%, %%item_predictive_score%%, %%item_curriculum_items%%, %%item_instructor_display_name%%, %%item_instructor_initials%%, %%item_instructor_image%%, %%item_instructor_job_title%%, %%item_instructor_url%%, %%item_instructor_title%%, %%item_instructor_name%%", 'learnomatic-udemy-affiliate-post-generator') . '
                           </div>
                       </div>
                       <b>' . esc_html__("Generated Post Content", 'learnomatic-udemy-affiliate-post-generator') . ':</b>&nbsp;<b><a href="https://coderevolution.ro/knowledge-base/faq/post-template-reference-advanced-usage/" target="_blank">&#9432;</a></b>
                       
                       </td><td>
                       <textarea rows="2" cols="70" name="learnomatic_rakuten_list[post_content][]" placeholder="Please insert your desired post content. Example:%%item_content%%" class="cr_width_full">' . htmlspecialchars($post_content) . '</textarea>
                           
           </div>
           </td></tr><tr><td>
           <div>
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text cr_min_260px">' . esc_html__("Do you want to try to get full content for courses? Please note that this feature will not use the API, but will scrape Udemy directly for data.", 'learnomatic-udemy-affiliate-post-generator') . '
                           </div>
                       </div>
                       <b>' . esc_html__("Try to Get Full Course Description", 'learnomatic-udemy-affiliate-post-generator') . ':</b>
                       
                       </td><td>
                       <input type="checkbox" id="full_content" name="learnomatic_rakuten_list[full_content][]"';
               if ($full_content == '1') {
                   $output .= ' checked';
               }
               $output .= '>
                           
           </div>
           </div></td></tr><tr><td colspan="2"><h4>' . esc_html__("Udemy Search Customization", 'learnomatic-udemy-affiliate-post-generator') . ':</h4></td></tr><tr><td>
           <div>
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text cr_min_260px">' . esc_html__("Select the course language you wish to use.", 'learnomatic-udemy-affiliate-post-generator') . '
                           </div>
                       </div>
                       <b>' . esc_html__("Course Language", 'learnomatic-udemy-affiliate-post-generator') . ':</b>
                       
                       </td><td>
                       <select id="language" name="learnomatic_rakuten_list[language][]" class="cr_width_full">
                       <option  value="any"';
           if ($language == 'any') {
               $output .= " selected";
           }
           $output .= '>' . esc_html__("Any", 'learnomatic-udemy-affiliate-post-generator') . '</option>';
           foreach ($learn_languages as $ltag => $lname) {
                   $output .= '<option value="' . esc_attr($ltag) . '"';
                   if ($ltag == $language) {
                       $output .= ' selected';
                   }
                   $output .= '>' . esc_html($lname) . '</option>';
               }
                       $output .= '</select>
           </div>
           </div></td></tr><tr><td>
           <div>
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text cr_min_260px">' . esc_html__("Select the course category you wish to use.", 'learnomatic-udemy-affiliate-post-generator') . '
                           </div>
                       </div>
                       <b>' . esc_html__("Course Category", 'learnomatic-udemy-affiliate-post-generator') . ':</b>
                       
                       </td><td>
                       <select id="source" name="learnomatic_rakuten_list[source][]" class="cr_width_full">
                       <option  value="any"';
           if ($source == 'any') {
               $output .= " selected";
           }
           $output .= '>' . esc_html__("Any", 'learnomatic-udemy-affiliate-post-generator') . '</option>
           <option  value="Business"';
           if ($source == 'Business') {
               $output .= " selected";
           }
           $output .= '>' . esc_html__("Business", 'learnomatic-udemy-affiliate-post-generator') . '</option>
           <option  value="Design"';
           if ($source == 'Design') {
               $output .= " selected";
           }
           $output .= '>' . esc_html__("Design", 'learnomatic-udemy-affiliate-post-generator') . '</option>
           <option  value="Development"';
           if ($source == 'Development') {
               $output .= " selected";
           }
           $output .= '>' . esc_html__("Development", 'learnomatic-udemy-affiliate-post-generator') . '</option>
           <option  value="Finance & Accounting"';
           if ($source == 'Finance & Accounting') {
               $output .= " selected";
           }
           $output .= '>' . esc_html__("Finance & Accounting", 'learnomatic-udemy-affiliate-post-generator') . '</option>
           <option  value="Health & Fitness"';
           if ($source == 'Health & Fitness') {
               $output .= " selected";
           }
           $output .= '>' . esc_html__("Health & Fitness", 'learnomatic-udemy-affiliate-post-generator') . '</option>
           <option  value="IT & Software"';
           if ($source == 'IT & Software') {
               $output .= " selected";
           }
           $output .= '>' . esc_html__("IT & Software", 'learnomatic-udemy-affiliate-post-generator') . '</option>
           <option  value="Lifestyle"';
           if ($source == 'Lifestyle') {
               $output .= " selected";
           }
           $output .= '>' . esc_html__("Lifestyle", 'learnomatic-udemy-affiliate-post-generator') . '</option>
           <option  value="Marketing"';
           if ($source == 'Marketing') {
               $output .= " selected";
           }
           $output .= '>' . esc_html__("Marketing", 'learnomatic-udemy-affiliate-post-generator') . '</option>
           <option  value="Music"';
           if ($source == 'Music') {
               $output .= " selected";
           }
           $output .= '>' . esc_html__("Music", 'learnomatic-udemy-affiliate-post-generator') . '</option>
           <option  value="Office Productivity"';
           if ($source == 'Office Productivity') {
               $output .= " selected";
           }
           $output .= '>' . esc_html__("Office Productivity", 'learnomatic-udemy-affiliate-post-generator') . '</option>
           <option  value="Personal Development"';
           if ($source == 'Personal Development') {
               $output .= " selected";
           }
           $output .= '>' . esc_html__("Personal Development", 'learnomatic-udemy-affiliate-post-generator') . '</option>
           <option  value="Photography"';
           if ($source == 'Photography') {
               $output .= " selected";
           }
           $output .= '>' . esc_html__("Photography", 'learnomatic-udemy-affiliate-post-generator') . '</option>
           <option  value="Teaching & Academics"';
           if ($source == 'Teaching & Academics') {
               $output .= " selected";
           }
           $output .= '>' . esc_html__("Teaching & Academics", 'learnomatic-udemy-affiliate-post-generator') . '</option>';
                       $output .= '</select>
           </div>
           </div></td></tr><tr><td>
           <div>
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text cr_min_260px">' . esc_html__("Rank courses by relevance, most-reviewed, highest-rated, newest, price-low-to-high, or price-high-to-low.", 'learnomatic-udemy-affiliate-post-generator') . '
                           </div>
                       </div>
                       <b>' . esc_html__("Results Ordering", 'learnomatic-udemy-affiliate-post-generator') . ':</b>
                       
                       </td><td>
                       <select id="ordering" name="learnomatic_rakuten_list[ordering][]" class="cr_width_full">
                       <option  value="any"';
           if ($ordering == 'any') {
               $output .= " selected";
           }
           $output .= '>' . esc_html__("Any", 'learnomatic-udemy-affiliate-post-generator') . '</option>
           <option  value="retailprice"';
           if ($ordering == 'retailprice') {
               $output .= " selected";
           }
           $output .= '>' . esc_html__("Price", 'learnomatic-udemy-affiliate-post-generator') . '</option>
           <option  value="productname"';
           if ($ordering == 'productname') {
               $output .= " selected";
           }
           $output .= '>' . esc_html__("Product Name", 'learnomatic-udemy-affiliate-post-generator') . '</option>
           <option  value="shortdesp"';
           if ($ordering == 'shortdesp') {
               $output .= " selected";
           }
           $output .= '>' . esc_html__("Product Description", 'learnomatic-udemy-affiliate-post-generator') . '</option>
           <option  value="categoryname"';
           if ($ordering == 'categoryname') {
               $output .= " selected";
           }
           $output .= '>' . esc_html__("Category Name", 'learnomatic-udemy-affiliate-post-generator') . '</option>
           <option  value="mid"';
           if ($ordering == 'mid') {
               $output .= " selected";
           }
           $output .= '>' . esc_html__("Merchant", 'learnomatic-udemy-affiliate-post-generator') . '</option>
           <option  value="keyword"';
           if ($ordering == 'keyword') {
               $output .= " selected";
           }
           $output .= '>' . esc_html__("Keyword", 'learnomatic-udemy-affiliate-post-generator') . '</option>';
                       $output .= '</select>
           </div>
           </td></tr><tr><td>
           <div>
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text cr_min_260px">' . esc_html__("Do you want to remember last posted item and continue search from it the next time the importing rule runs?", 'learnomatic-udemy-affiliate-post-generator') . '
                           </div>
                       </div>
                       <b>' . esc_html__("Cache Items For Continuous Posting (disable to get latest posts only)", 'learnomatic-udemy-affiliate-post-generator') . ':</b>
                       
                       </td><td>
                       <input type="checkbox" id="continue_search" name="learnomatic_rakuten_list[continue_search][]"';
               if ($continue_search == '1') {
                   $output .= ' checked';
               }
               $output .= '>
                           
           </div>
           </td></tr><tr><td colspan="2"><h4>' . esc_html__("Generated Post Customization", 'learnomatic-udemy-affiliate-post-generator') . ':</h4></td></tr><tr><td class="cr_min_width_200">
           <div>
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text cr_min_260px">' . esc_html__('If your template supports "Post Formats", than you can select one here. If not, leave this at it\'s default value.', 'learnomatic-udemy-affiliate-post-generator') . '
                           </div>
                       </div>
                       <b>' . esc_html__("Generated Post Format", 'learnomatic-udemy-affiliate-post-generator') . ':</b>   
                       </td><td>
                       <select id="post_format" name="learnomatic_rakuten_list[post_format][]" class="cr_width_full">
                       <option value="post-format-standard"';
               if ($post_format == 'post-format-standard') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("Standard", 'learnomatic-udemy-affiliate-post-generator') . '</option>
                       <option value="post-format-aside"';
               if ($post_format == 'post-format-aside') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("Aside", 'learnomatic-udemy-affiliate-post-generator') . '</option>
                       <option value="post-format-gallery"';
               if ($post_format == 'post-format-gallery') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("Gallery", 'learnomatic-udemy-affiliate-post-generator') . '</option>
                       <option value="post-format-link"';
               if ($post_format == 'post-format-link') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("Link", 'learnomatic-udemy-affiliate-post-generator') . '</option>
                       <option value="post-format-image"';
               if ($post_format == 'post-format-image') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("Image", 'learnomatic-udemy-affiliate-post-generator') . '</option>
                       <option value="post-format-quote"';
               if ($post_format == 'post-format-quote') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("Quote", 'learnomatic-udemy-affiliate-post-generator') . '</option>
                       <option value="post-format-status"';
               if ($post_format == 'post-format-status') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("Status", 'learnomatic-udemy-affiliate-post-generator') . '</option>
                       <option value="post-format-video"';
               if ($post_format == 'post-format-video') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("Video", 'learnomatic-udemy-affiliate-post-generator') . '</option>
                       <option value="post-format-audio"';
               if ($post_format == 'post-format-audio') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("Audio", 'learnomatic-udemy-affiliate-post-generator') . '</option>
                       <option value="post-format-chat"';
               if ($post_format == 'post-format-chat') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("Chat", 'learnomatic-udemy-affiliate-post-generator') . '</option>
                   </select>     
           </div>
           </td></tr><tr><td class="cr_min_width_200">
           <div>
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text cr_min_260px">' . esc_html__("Select the post category that you want for the automatically generated posts to have.", 'learnomatic-udemy-affiliate-post-generator') . '
                           </div>
                       </div>
                       <b>' . esc_html__("Additional Post Category", 'learnomatic-udemy-affiliate-post-generator') . ':</b>
                       
                       </td><td>
                       <select class="cr_width_full" id="default_category" name="learnomatic_rakuten_list[default_category][]">
                       <option value="learnomatic_no_category_12345678">' . esc_html__("Do Not Add a Category", 'learnomatic-udemy-affiliate-post-generator') . '</option>';
               foreach ($categories as $category) {
                   $output .= '<option value="' . esc_attr($category->term_id) . '"';
                   if ($category->term_id == $default_category) {
                       $output .= ' selected';
                   }
                   $output .= '>' . sanitize_text_field($category->name) . '</option>';
               }
               $output .= '</select>     
           </div>
           </td></tr><tr><td>
           <div>
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text cr_min_260px">' . esc_html__("Do you want to automatically add post categories from the feed items?", 'learnomatic-udemy-affiliate-post-generator') . '
                           </div>
                       </div>
                       <b>' . esc_html__("Auto Add Categories", 'learnomatic-udemy-affiliate-post-generator') . ':</b>
                       
                       </td><td>
                       <select class="cr_width_full" id="auto_categories" name="learnomatic_rakuten_list[auto_categories][]">
                       <option value="disabled"';
               if ($auto_categories == 'disabled') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("Disabled", 'learnomatic-udemy-affiliate-post-generator') . '</option>
                       <option value="coursep"';
               if ($auto_categories == 'coursep') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("Course Primary Category", 'learnomatic-udemy-affiliate-post-generator') . '</option>
                       <option value="courses"';
               if ($auto_categories == 'courses') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("Course Secondary Category", 'learnomatic-udemy-affiliate-post-generator') . '</option>
               <option value="course"';
               if ($auto_categories == 'course') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("Course Primary & Secondary Category", 'learnomatic-udemy-affiliate-post-generator') . '</option>
                       <option value="title"';
               if ($auto_categories == 'title') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("Title", 'learnomatic-udemy-affiliate-post-generator') . '</option>
                       
                       </select>                
           </div>
           </td></tr><tr><td>
           <div>
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text cr_min_260px">' . esc_html__("This feature will try to remove the WordPress\'s default post category. This may fail in case no additional categories are added, because WordPress requires at least one post category for every post.", 'learnomatic-udemy-affiliate-post-generator') . '
                           </div>
                       </div>
                       <b>' . esc_html__("Remove WP Default Post Category", 'learnomatic-udemy-affiliate-post-generator') . ':</b>
                       
                       </td><td>
                       <input type="checkbox" id="remove_default" name="learnomatic_rakuten_list[remove_default][]"';
           if($remove_default == '1')
           {
               $output .= ' checked';
           }
           $output .= '>
                           
           </div>
           </td></tr><tr><td>
           <div>
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text cr_min_260px">' . esc_html__("Do you want to automatically add post tags from the feed items?", 'learnomatic-udemy-affiliate-post-generator') . '
                           </div>
                       </div>
                       <b>' . esc_html__("Auto Add Tags", 'learnomatic-udemy-affiliate-post-generator') . ':</b>
                       
                       </td><td>
                       <select class="cr_width_full" id="auto_tags" name="learnomatic_rakuten_list[auto_tags][]">
                       <option value="disabled"';
               if ($auto_tags == 'disabled') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("Disabled", 'learnomatic-udemy-affiliate-post-generator') . '</option>
                       <option value="coursep"';
               if ($auto_tags == 'coursep') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("Course Primary Category", 'learnomatic-udemy-affiliate-post-generator') . '</option>
                       <option value="courses"';
               if ($auto_tags == 'courses') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("Course Secondary Category", 'learnomatic-udemy-affiliate-post-generator') . '</option>
               <option value="course"';
               if ($auto_tags == 'course') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("Course Primary & Secondary Category", 'learnomatic-udemy-affiliate-post-generator') . '</option>
                       <option value="title"';
               if ($auto_tags == 'title') {
                   $output .= ' selected';
               }
               $output .= '>' . esc_html__("Title", 'learnomatic-udemy-affiliate-post-generator') . '</option>
                       </select>     
           </div>
           </td></tr><tr><td>
           <div>
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text cr_min_260px">' . esc_html__("Select the post tags that you want for the automatically generated posts to have.", 'learnomatic-udemy-affiliate-post-generator') . '
                           </div>
                       </div>
                       <b>' . esc_html__("Additional Post Tags", 'learnomatic-udemy-affiliate-post-generator') . ':</b>
                       
                       </td><td>
                       <input class="cr_width_full" type="text" name="learnomatic_rakuten_list[default_tags][]" value="' . esc_attr($default_tags) . '" placeholder="Please insert your additional post tags here" >
                           
           </div>
           </td></tr><tr><td>
           <div>
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text cr_min_260px">' . esc_html__("Do you want to limit the title\'s length to a specific word count? To disable this feature, leave this field blank.", 'learnomatic-udemy-affiliate-post-generator') . '
                           </div>
                       </div>
                       <b>' . esc_html__("Limit Title Word Count", 'learnomatic-udemy-affiliate-post-generator') . ':</b>
                       
                       </td><td>
                       <input type="number" min="1" step="1" id="limit_title_word_count" name="learnomatic_rakuten_list[limit_title_word_count][]" value="' . esc_attr($limit_title_word_count) . '" placeholder="Please insert a title limit count" class="cr_width_full">
                           
           </div>
           </td></tr><tr><td>
           <div>
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text cr_min_260px">' . esc_html__("Do you want to limit the content\'s length to a specific word count? To disable this feature, leave this field blank.", 'learnomatic-udemy-affiliate-post-generator') . '
                           </div>
                       </div>
                       <b>' . esc_html__("Limit Content Word Count", 'learnomatic-udemy-affiliate-post-generator') . ':</b>
                       
                       </td><td>
                       <input type="number" min="1" step="1" id="limit_content_word_count" name="learnomatic_rakuten_list[limit_content_word_count][]" value="' . esc_attr($limit_content_word_count) . '" placeholder="Please insert a limit for content" class="cr_width_full">
                           
           </div>
           </td></tr><tr><td>
           <div>
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text cr_min_260px">' . esc_html__("Make permalinks (title and image) link directly to the post\'s source url. Warning: posts will not load at your site!", 'learnomatic-udemy-affiliate-post-generator') . '
                           </div>
                       </div>
                       <b>' . esc_html__("Permalinks Link To Source", 'learnomatic-udemy-affiliate-post-generator') . ':</b>
                       
                       </td><td>
                       <input type="checkbox" id="title_link" name="learnomatic_rakuten_list[title_link][]"';
               if ($title_link == '1') {
                   $output .= ' checked';
               }
               $output .= '>
                           
           </div>
           </td></tr><tr><td>
           <div>
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text cr_min_260px">' . esc_html__("Do you want to link post images to original article source?", 'learnomatic-udemy-affiliate-post-generator') . '
                           </div>
                       </div>
                       <b>' . esc_html__("Link Post Images To Source", 'learnomatic-udemy-affiliate-post-generator') . ':</b>
                       
                       </td><td>
                       <input type="checkbox" id="add_link_img" name="learnomatic_rakuten_list[add_link_img][]"';
               if ($add_link_img == '1') {
                   $output .= ' checked';
               }
               $output .= '>
                           
           </div>
           </td></tr><tr><td>
           <div>
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text cr_min_260px">' . esc_html__("Do you want to enable comments for the generated posts?", 'learnomatic-udemy-affiliate-post-generator') . '
                           </div>
                       </div>
                       <b>' . esc_html__("Enable Comments For Posts", 'learnomatic-udemy-affiliate-post-generator') . ':</b>
                       
                       </td><td>
                       <input type="checkbox" id="enable_comments" name="learnomatic_rakuten_list[enable_comments][]"';
               if ($enable_comments == '1') {
                   $output .= ' checked';
               }
               $output .= '>
                           
           </div>
           </td></tr><tr><td>
           <div>
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text cr_min_260px">' . esc_html__("Do you want to enable pingbacks and trackbacks for the generated posts?", 'learnomatic-udemy-affiliate-post-generator') . '
                           </div>
                       </div>
                       <b>' . esc_html__("Enable Pingback/Trackback", 'learnomatic-udemy-affiliate-post-generator') . ':</b>
                       
                       </td><td>
                       <input type="checkbox" id="enable_pingback" name="learnomatic_rakuten_list[enable_pingback][]"';
               if ($enable_pingback == '1') {
                   $output .= ' checked';
               }
               $output .= '>
                           
           </div>
           </td></tr><tr><td>
           <div>
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text cr_min_260px">' . esc_html__("Do you want to set featured image for generated post (to the first image that was found in the post)?", 'learnomatic-udemy-affiliate-post-generator') . '
                           </div>
                       </div>
                       <b>' . esc_html__("Auto Get Featured Image", 'learnomatic-udemy-affiliate-post-generator') . ':</b>
                       
                       </td><td>
                       <input type="checkbox" id="featured_image" name="learnomatic_rakuten_list[featured_image][]"';
               if ($featured_image == '1') {
                   $output .= ' checked';
               }
               $output .= '>
                           
           </div>
           </td></tr><tr><td>
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text cr_min_260px">' . esc_html__("Insert a comma separated list of links to valid images that will be set randomly for the featured image for the posts that do not have a valid image attached or if you disabled automatical featured image generation. You can also use image numeric IDs from images found in the Media Gallery. To disable this feature, leave this field blank.", 'learnomatic-udemy-affiliate-post-generator') . '
                           </div>
                       </div>
                       <b>' . esc_html__("Default Featured Image List", 'learnomatic-udemy-affiliate-post-generator') . ':</b>
                       </td><td>
                       <input class="cr_width_full" type="text" name="learnomatic_rakuten_list[image_url][]" placeholder="Please insert the link to a valid image" value="' . esc_attr($image_url) . '"/>
                       
           </td></tr><tr><td class="cr_min_width_200">
           <div>
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text cr_min_260px">' . esc_html__("Set the custom fields that will be set for generated posts. The syntax for this field is the following: custom_field_name1 => custom_field_value1, custom_field_name2 => custom_field_value2, ... . In custom_field_valueX, you can use shortcodes, same like in post content. You can also assign the data to array custom fields, using this format: array_field[index_name1] => custom_field_value1, array_field[index_name2] => custom_field_value2. Example (without quotes): \'title_custom_field => %%item_title%%\'. You can use the following shortcodes: %%item_title%%, %%item_content%%, %%item_id%%, %%item_url%%, %%item_content_plain_text%%, %%item_cats%%, %%item_tags%%, %%random_sentence%%, %%random_sentence2%%, %%custom_html%%, %%custom_html2%%, %%item_buy_now_button%%, %%item_show_image%%, %%item_image_URL%%, %%item_description%%, %%item_presentation%%, %%item_description_iframe%%, %%item_price%%, %%item_get_intro%%, %%item_price_currency%%, %%item_price_currency_symbol%%, %%item_price_amount%%, %%item_id_title%%, %%item_predictive_score%%, %%item_curriculum_items%%, %%item_instructor_display_name%%, %%item_instructor_initials%%, %%item_instructor_image%%, %%item_instructor_job_title%%, %%item_instructor_url%%, %%item_instructor_title%%, %%item_instructor_name%%", 'learnomatic-udemy-affiliate-post-generator') . '
                           </div>
                       </div>
                       <b>' . esc_html__("Post Custom Fields", 'learnomatic-udemy-affiliate-post-generator') . ':</b>&nbsp;<b><a href="https://coderevolution.ro/knowledge-base/faq/post-template-reference-advanced-usage/" target="_blank">&#9432;</a></b>
                       
                       </td><td>
                       <textarea rows="1" cols="70" name="learnomatic_rakuten_list[custom_fields][]" placeholder="Please insert your desired custom fields. Example: title_custom_field => %%item_title%%" class="cr_width_full">' . esc_textarea($custom_fields) . '</textarea>
                           
           </div>
           </td></tr><tr><td class="cr_min_width_200">
           <div>
           <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">
                                           <div class="bws_hidden_help_text cr_min_260px">' . esc_html__("Set the custom taxonomies that will be set for generated posts. The syntax for this field is the following: custom_taxonomy_name1 => custom_taxonomy_value1A, custom_taxonomy_value1B; custom_taxonomy_name2 => custom_taxonomy_value2A, custom_taxonomy_value2B; ... . In custom_taxonomy_valueX, you can use shortcodes. Example (without quotes): \'cats_taxonomy_field => manualtax1, %%item_tags%%; tags_taxonomy_field => manualtax2, %%item_tags%%\'. You can use the following shortcodes: %%item_title%%, %%item_content%%, %%item_id%%, %%item_url%%, %%item_content_plain_text%%, %%item_cats%%, %%item_tags%%, %%random_sentence%%, %%random_sentence2%%, %%custom_html%%, %%custom_html2%%, %%item_buy_now_button%%, %%item_show_image%%, %%item_image_URL%%, %%item_description%%, %%item_presentation%%, %%item_description_iframe%%, %%item_price%%, %%item_get_intro%%, %%item_price_currency%%, %%item_price_currency_symbol%%, %%item_price_amount%%, %%item_id_title%%, %%item_predictive_score%%, %%item_curriculum_items%%, %%item_instructor_display_name%%, %%item_instructor_initials%%, %%item_instructor_image%%, %%item_instructor_job_title%%, %%item_instructor_url%%, %%item_instructor_title%%, %%item_instructor_name%%. If you defined custom tag names in the \'Feed Item Custom Tag Names\' settings field in plugin\'s \'Main Settings\', you will also be able to use a shortcode for each inserted field name, in this format: %%custom_*field_name*%%", 'learnomatic-udemy-affiliate-post-generator') . '
                           </div>
                       </div>
                       <b>' . esc_html__("Post Custom Taxonomies", 'learnomatic-udemy-affiliate-post-generator') . ':</b>&nbsp;<b><a href="https://coderevolution.ro/knowledge-base/faq/post-template-reference-advanced-usage/" target="_blank">&#9432;</a></b>
                       </td><td>
                         <textarea rows="1" cols="70" name="learnomatic_rakuten_list[custom_tax][]" placeholder="Please insert your desired custom taxonomies. Example: custom_taxonomy_name => %%item_cats%%" class="cr_width_full">' . esc_textarea($custom_tax) . '</textarea>  
           </div>
           </td></tr></table></div> 
       </div>
       <div class="codemodalfzr-footer">
         <br/>
         <h3 class="cr_inline">Learnomatic Udemy Affiliate Post Generator</h3><span id="learnomatic_ok' . esc_html($cont) . '" class="codeokfzr cr_inline">OK&nbsp;</span>
         <br/><br/>
       </div>
     </div>
   
   </div>    
                       </td>
   						<td class="cr_shrt_td2"><span class="wplearnomatic-delete">X</span></td>
                           <td class="cr_short_td"><input type="checkbox" name="learnomatic_rakuten_list[active][]" class="activateDeactivateClass" value="1"';
               if (isset($active) && $active === '1') {
                   $output .= ' checked';
               }
               $output .= '/>
                           <input type="hidden" name="learnomatic_rakuten_list[last_run][]" value="' . esc_attr($last_run) . '"/></td>
                           <td class="cr_shrt_td2"><div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help cr_align_middle">';
                           if (isset($learnomatic_Main_Settings['no_check']) && $learnomatic_Main_Settings['no_check'] == 'on')
                           {
                               $output .= '<div class="bws_hidden_help_text cr_min_260px">';if(isset($learnomatic_Main_Settings['secret_word']) && $learnomatic_Main_Settings['secret_word'] != ''){$output .= sprintf( wp_kses( __( 'Secret Word For Direct Run:', 'learnomatic-udemy-affiliate-post-generator'), array(  'br' => array( ) ) ) ) . '<br/><b>?run_learnomatic=' . urlencode($learnomatic_Main_Settings['secret_word']) . '_1_' . esc_html($cont) . '</b><br/>';}$output .= sprintf( wp_kses( __( 'Shortcode for this rule<br/>(to cross-post from this plugin in other plugins):', 'learnomatic-udemy-affiliate-post-generator'), array(  'br' => array( ) ) ) ) . '<br/><b>%%learnomatic_1_' . esc_html($cont) . '%% and %%learnomatic_title_1_' . esc_html($cont) . '%%</b><br/>' . esc_html__('Posts Generated:', 'learnomatic-udemy-affiliate-post-generator') . ' ' . esc_html__('post count checking disabled from plugin settings', 'learnomatic-udemy-affiliate-post-generator') . '<br/>';
                           }
                           else
                           {
                               $output .= '<div class="bws_hidden_help_text cr_min_260px">';if(isset($learnomatic_Main_Settings['secret_word']) && $learnomatic_Main_Settings['secret_word'] != ''){$output .= sprintf( wp_kses( __( 'Secret Word For Direct Run:', 'learnomatic-udemy-affiliate-post-generator'), array(  'br' => array( ) ) ) ) . '<br/><b>?run_learnomatic=' . urlencode($learnomatic_Main_Settings['secret_word']) . '_1_' . esc_html($cont) . '</b><br/>';}$output .= sprintf( wp_kses( __( 'Shortcode for this rule<br/>(to cross-post from this plugin in other plugins):', 'learnomatic-udemy-affiliate-post-generator'), array(  'br' => array( ) ) ) ) . '<br/><b>%%learnomatic_1_' . esc_html($cont) . '%% and %%learnomatic_title_1_' . esc_html($cont) . '%%</b><br/>' . esc_html__('Posts Generated:', 'learnomatic-udemy-affiliate-post-generator') . ' ' . esc_html($generated_posts) . '<br/>';
                           }
               if ($generated_posts != 0) {
                   $output .= '<a href="' . get_admin_url() . 'edit.php?coderevolution_post_source=Learnomatic_1_' . esc_html($cont) . '&post_type=' . esc_html($def_type) . '" target="_blank">' . esc_html__('View Generated Posts', 'learnomatic-udemy-affiliate-post-generator') . '</a><br/>';
               }
               $output .= esc_html__('Last Run: ', 'learnomatic-udemy-affiliate-post-generator');
               if ($last_run == '1988-01-27 00:00:00') {
                   $output .= 'Never';
               } else {
                   $output .= $last_run;
               }
               $now     = learnomatic_get_date_now();
               $output .= '<br/>' . esc_html__('Next Run: ', 'learnomatic-udemy-affiliate-post-generator');
               if ( defined( 'DISABLE_WP_CRON' ) && DISABLE_WP_CRON ) {
                   $output .= esc_html__('WP-CRON Disabled. Rules will not automatically run!', 'learnomatic-udemy-affiliate-post-generator');
               }
               else
               {
                   $nextrun = learnomatic_add_hour($last_run, $schedule);
                   if (isset($active) && $active === '1') {
                       $learnomatic_hour_diff = (int) learnomatic_hour_diff($now, $nextrun);
                       if ($learnomatic_hour_diff >= 0) {
                           $append = 'Now.';
                           $cron   = _get_cron_array();
                           if ($cron != FALSE) {
                               $date_format = _x('Y-m-d H:i:s', 'Date Time Format1', 'learnomatic-udemy-affiliate-post-generator');
                               foreach ($cron as $timestamp => $cronhooks) {
                                   foreach ((array) $cronhooks as $hook => $events) {
                                       if ($hook == 'learnomaticaction') {
                                           foreach ((array) $events as $key => $event) {
                                               $append = date_i18n($date_format, $timestamp);
                                           }
                                       }
                                   }
                               }
                           }
                           $output .= $append;
                       } else {
                           $output .= $nextrun;
                       }
                   } else {
                       $output .= esc_html__('Rule Disabled', 'learnomatic-udemy-affiliate-post-generator');
                   }
               }
               $output .= '<br/>' . esc_html__('Local Time: ', 'learnomatic-udemy-affiliate-post-generator') . $now;
               $output .= '</div>
                       </div></td>
                           <td class="cr_center">
                           <div>
                           <img id="run_img' . esc_html($cont) . '" src="' . plugin_dir_url(dirname(__FILE__)) . 'images/running.gif' . '" alt="Running" class="cr_status_icon';
               if (!empty($running)) {
                   if (!in_array(array($cont => 0), $running)) {
                       $output .= ' cr_hidden';
                   }
                   else
                   {
                       $f = fopen(get_temp_dir() . 'learnomatic_1_' . $cont, 'w');
                       if($f !== false)
                       {
                           if (!flock($f, LOCK_EX | LOCK_NB)) {
                           }
                           else
                           {
                               $output .= ' cr_hidden';
                               flock($f, LOCK_UN);
                               if (($xxkey = array_search(array($cont => 0), $running)) !== false) {
                                   unset($running[$xxkey]);
                                   update_option('learnomatic_running_list', $running);
                               }
                           }
                       }
                   }
               } else {
                   $output .= ' cr_hidden';
               }
               $output .= '" title="status">
                           <div class="codemainfzr">
                           <select id="actions" class="actions" name="actions" onchange="actionsChangedManual(' . esc_html($cont) . ', this.value, 1);" onfocus="this.selectedIndex = 0;">
                               <option value="select" disabled selected>' . esc_html__("Select an Action", 'learnomatic-udemy-affiliate-post-generator') . '</option>
                               <option value="run">' . esc_html__("Run This Rule Now", 'learnomatic-udemy-affiliate-post-generator') . '</option>
                               <option value="trash">' . esc_html__("Move All Posts To Trash", 'learnomatic-udemy-affiliate-post-generator') . '</option>
                               <option value="duplicate">' . esc_html__("Duplicate This Rule", 'learnomatic-udemy-affiliate-post-generator') . '</option>
                               <option value="delete">' . esc_html__("Permanently Delete All Posts", 'learnomatic-udemy-affiliate-post-generator') . '</option>
                           </select>
                           </div>
                           </div>
                           </td>
   					</tr>	
   					';
               $cont = $cont + 1;
           }
       }
       return $output;
   }
   ?>